'### coresound ###

SuperStrict

Module modulo.coresound

ModuleInfo "Author: Johannes Wolf"
ModuleInfo "Version: 1.00"
ModuleInfo "License: -"

'imports
Import pub.OpenAL
Import brl.AudioSample
Import brl.oggLoader
Import brl.wavLoader
Import brl.linkedlist
Import brl.stream
Import brl.filesystem
Import brl.standardio

Const CSName:String = "CoreSound"
Const CSVersion:String = "1.00" 

'includes
Include "cs.const.bmx"
Include "cs.audiosample.bmx"
Include "cs.sound.bmx"

Rem
bbdoc: CoreSound main class.
EndRem
Type CoreSound Final

	Global device:Int
	Global context:Int
	
	Function init()
		alGetError()
		CoreSound.device = alcOpenDevice(Null)
		If alGetError() CoreSoundError("Error setting up device!")
		
		alGetError()
		Local dummy:Int Ptr
		CoreSound.context = alcCreateContext(CoreSound.device, dummy)
		alcMakeContextCurrent(CoreSound.context)
		If alGetError() CoreSoundError("Error setting up context!")
		
		OnEnd(CoreSoundDeinit)
		
		?debug
			WriteStdout("[" + CSName + " " + CSVersion + "] init~n")
		?
	EndFunction
	
	Function deinit()
		alGetError()
		alcDestroyContext( CoreSound.context )
		If alGetError() CoreSoundError("Error destroying context!")
		alcCloseDevice( CoreSound.device )
		If alGetError() CoreSoundError("Error closing device!")
		
		For Local sound:CSSound = EachIn(CSSound.sounds)
			If sound sound.deinit()
		Next
		GCCollect()
		
		?debug
			WriteStdout("[" + CSName + " " + CSVersion + "] deinit~n")
		?
	EndFunction
	
	Function update()
		'If CSSound.sounds
		'	For Local streamed:CSStreamedSound = EachIn(CSSound.sounds)
		'		streamed.updateStream()
		'	Next
		'EndIf
	EndFunction

EndType

Function CoreSoundError( message_:String )
	Throw CSName + ": " + message_
EndFunction

Function CoreSoundInit()
	CoreSound.init()
EndFunction

Function CoreSoundDeinit:Int()
	CoreSound.deinit()
EndFunction