'### coresound.streamedsound ###'
'
' -=== Baustelle ===-
' Funktioniert noch nicht ganz ;)
'
'
'


Const CS_STREAM_BUFFER_SIZE:Int = 1024*1000

Rem
bbdoc: CSStreamedSound provides simple streamed sound playback functionality.
EndRem
Type CSStreamedSound Extends CSSound

	Field _sformat:Int 'bmx format
	Field _slength:Int 'data length
	Field _hlength:Int 'header length
	
	Field _url:String
	Field _stream:TStream
	
	Field _totalsamples:Long
	Field _sample:TAudioSample
	Field _stop:Int
		
	'------
	'create
	'------
	
	Rem
	bbdoc: Initializes the CSStreamedSound instance.
	EndRem
	Method init()
		If Not CSSound.sounds CSSound.sounds = CreateList() 
		generateBuffers(3)
		generateSources()
		CSSound.sounds.addLast(Self)
	EndMethod
	
	'---------
	'set & get
	'---------
	

	'----
	'load
	'----
	
	Rem
	bbdoc: Load a sound (only wav) into a CSStreamedSound.
	about: Only support WAV files!
	EndRem
	Method LoadWAV( url_:String, _save:Int=False )
		_url = url_
		_stream = ReadStream(url_)
		If Not _stream CoreSoundError( "Error loading from stream!" )
		
		Local snd_:TAudioSample = loadWAVHeader(_stream, _slength, _hlength)
		If Not snd_ CoreSoundError( "Error reading WAV header!" )
		
		_hertz = snd_.hertz
		_sformat = snd_.format
		_format = AudioFormatToALFormat( snd_.format )
		_length = snd_.length
		_byte = AudioFormatMonoOrStereo( snd_.format )
		_totalsamples = 0
		_stop = 0
		
		alGetError()
		loadAllBuffers()
	EndMethod
	
	'---------
	'overwrite
	'---------
	
	Method getLoop:Int()
		Return 0
	EndMethod
	
	Method setLoop( loop_:Int )
		Return
	EndMethod
	
	Method stop()
		alGetError()
		If _source[0] Then alSourceStop( _source[0] )
		_totalsamples = 0
	EndMethod
	
	Method rewind()
		alGetError()
		If _source[0] Then alSourceRewind( _source[0] )
	EndMethod
	
	Method getSampleOffset:Long()
		Local ret_:Int
		alGetSourcei( _source[0], AL_SAMPLE_OFFSET, Varptr(ret_) )
		Return ret_ + _totalsamples
	EndMethod

	Method setSampleOffset( smp_:Int )
		'bu bug bug bug bug bug bug
		Local _streamPos:Int = _hlength + smp_
		If SeekStream(_stream, _streampos)
			reloadStream()
			SeekStream(_stream, _streampos)
			play()
		Else
			Print "stream is not seekable!"
		EndIf
	EndMethod

	'------
	'update
	'------
	
	Method reloadStream()
		stop()
		alGetError()
		alSourceUnqueueBuffers(getSource(), _buffercount, _buffer)
		If alGetError() CoreSoundError( "Error unqueueing buffers!" )
		CloseStream(_stream)
		Load(_url, False)
	EndMethod

	Method loadAllBuffers()
		For Local i:Int = 0 Until _buffercount			
			'read from the stream into a sound sample
			Local bread:Int = 0
			If Not Eof(_stream) And _stream
				If StreamSize(_stream)-StreamPos(_stream)> CS_STREAM_BUFFER_SIZE
					_sample = CreateAudioSample(CS_STREAM_BUFFER_SIZE, _hertz, _sformat)
					bread = _stream.readbytes(_sample.samples, CS_STREAM_BUFFER_SIZE)
				Else
					_sample = CreateAudioSample(StreamSize(_stream)-StreamPos(_stream), _hertz, _sformat)
					bread = _stream.readbytes(_sample.samples, StreamSize(_stream)-StreamPos(_stream))
				EndIf
			Else
				'_stop = True
				'Exit
			EndIf
			
			alGetError()
			alBufferData( _buffer[i], _format, _sample.samples, _sample.length, _sample.hertz )
			If alGetError() CoreSoundError( "Error buffering data!" )
		Next
		
		alGetError()
		alSourceQueueBuffers(getSource(), _buffercount, _buffer)
		If alGetError() CoreSoundError( "Error queueing buffers!" )
	EndMethod

	Method updateStream()
		Local count:Int = 0
		alGetSourcei(getSource(), AL_BUFFERS_PROCESSED, Varptr(count))
		If count And Not Eof(_stream)
			Print "buffering new data from stream"
			For Local i:Int = 1 To count
				Local buffer:Int
				alGetError()
				alSourceUnqueueBuffers(getSource(), 1, Varptr(buffer))
				If alGetError() CoreSoundError( "Error unqueueing buffer!" )
				
				'read from the stream into a sound sample
				If Not Eof(_stream) And _stream
					Local bread:Int = 0
					If StreamSize(_stream)-StreamPos(_stream)> CS_STREAM_BUFFER_SIZE
						_sample = CreateAudioSample(CS_STREAM_BUFFER_SIZE, _hertz, _sformat)
						bread = _stream.readbytes(_sample.samples, CS_STREAM_BUFFER_SIZE)
					Else
						_sample = CreateAudioSample(StreamSize(_stream)-StreamPos(_stream), _hertz, _sformat)
						bread = _stream.readbytes(_sample.samples, StreamSize(_stream)-StreamPos(_stream))
					EndIf
				EndIf
				
				alGetError()
				alBufferData( buffer, _format, _sample.samples, _sample.length, _sample.hertz )
				If alGetError() CoreSoundError( "Error buffering data!" )
				
				alGetError()
				alSourceQueueBuffers(getSource(), 1, Varptr(buffer))
				If alGetError() CoreSoundError( "Error queueing buffer!" )
				
				_totalsamples :+ _sample.length/_byte
				
			Next
			
			Local playing:Int = 0
			alGetSourcei(getSource(), AL_SOURCE_STATE, Varptr(playing))
			If playing <> AL_PLAYING
				play()
			EndIf
		'ElseIf Eof(_stream)
			'Local playing:Int = 0
			'alGetSourcei(getSource(), AL_SOURCE_STATE, Varptr(playing))
			'If Not playing <> AL_PLAYING
			'	stop()
			'EndIf
		EndIf
	EndMethod

EndType

Private
'stream, stream data length, stream header length
Function loadWAVHeader:TAudioSample( stream_:TStream, slength_:Int Var, shpos_:Int Var )
		stream_ = LittleEndianStream(stream_)
		
		If Not readtag(stream_, "RIFF") Return Null

		Local w_len:Int=stream_.ReadInt()-8

		If Not readtag(stream_, "WAVE") Return Null
		If Not readtag(stream_, "fmt ") Return Null

		Local w_len2:Int=stream_.ReadInt()
		
		Local w_comp:Short=stream_.ReadShort()
		If w_comp<>1 Return Null
		
		Local w_chans:Short=stream_.ReadShort()
		Local w_hz:Int=stream_.ReadInt()
		Local w_bytespersec:Int=stream_.ReadInt()
		Local w_pad:Short=stream_.ReadShort()
		Local w_bits:Short=stream_.ReadShort()
		
		Local format:Int = 0
		Select True
		Case w_bits=8 And w_chans=1 
			format=SF_MONO8
		Case w_bits=8 And w_chans=2 
			format=SF_STEREO8
		Case w_bits=16 And w_chans=1
			format=SF_MONO16LE
		Case w_bits=16 And w_chans=2
			format=SF_STEREO16LE
		Default
			Return Null
		End Select

		If w_len2>16 stream_.SkipBytes( w_len2-16 )

		While Not readtag(stream_, "data")
			Local sz:Int=stream_.ReadInt()
			stream_.SkipBytes( sz )
		Wend
		shpos_ = StreamPos(stream_)

		Local w_sizebytes:Int=stream_.ReadInt()
		slength_ = w_sizebytes
		Local length:Long=w_sizebytes/BytesPerSample[format],hertz:Double=w_hz
		Return TAudioSample.Create( length,hertz,format ) 
	
		'stream_.ReadBytes t.samples,w_sizebytes
EndFunction

Public

