'Simple demo to show how easy it is to play soundfiles with CoreSound.

SuperStrict

'import the CoreSound module.
Import modulo.coresound

'create a graphics window
Graphics(400, 300)

'initialize CoreSound
'if not an exception will be thrown.
CoreSoundInit()

'create a new CSSound instance.
'CSSound is a simple to use sound playback class.
'the sound are loaded throu TAudioSample.
'(sounds created with 'sound' or 'create' are already initialized).
Local sound:CSSound = CSSound.Create()

'to load a 'wav' file we need to call the method 'load'.
'it takes an object parameter, that can be a path to a file.
'the last optional paramter sets if the soundsample should be saved in the '_sample' field.
sound.LoadWAV(RequestFile("Audio File", "Sound:wav;"), True)

'if the sound is loaded we can modify channel settings like 'pitch', 'loop' or 'gain'.
sound.setGain(1.0)
sound.setPitch(1.0)
sound.setLoop(False)

'and now just play the sound.
'you can do this with the method 'play'.
'to pause or stop the sound use 'pause' / 'stop'.
sound.play()

'while the sound is playing, draw a bar that represents the playing position
Repeat

	'draw the bar and the current durration
	'.... 
	SetColor( 100, 100, 100 )
	DrawRect( 10, 10, 380.0, 12 )
	DrawText( sound.getCurrentTimeString() + " - " + sound.getTimeString(), 10, 24)
	SetColor( 255, 255, 255 )
	DrawRect( 10, 10, (380.0/sound._length)*(sound.getSampleOffset()), 12 )
	
	'spooling
	If MouseX() >= 10 And MouseY() >= 10 And MouseX() <= 390 And MouseY() <= 22
		If MouseDown(1)
			sound.setCurrentTime( sound.getTime()/380.0*(MouseX()-12.0) )
		EndIf
	EndIf
	If KeyHit(key_space) sound.play()
	'//
	
	CoreSound.update()

Flip ; Cls
Until AppTerminate()